<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns="http://dita.oasis-open.org/architecture/2005/"
    xmlns:ditaarch="http://dita.oasis-open.org/architecture/2005/"
    xmlns:ditaaccess="java:ro.sync.ecss.dita.extensions.DITAXSLTExtensionFunctionUtil"
    exclude-result-prefixes="#all"
    version="3.0">

    <xsl:param name="show.csv.messages" as="xs:boolean" select="false()"/>
    <xsl:param name="add.comments" as="xs:boolean" select="false()"/>

    <xsl:variable name="doc" select="document-uri()"/>

    <xsl:mode on-no-match="shallow-copy"/>

    <!-- show value of API calls for every link -->
    <xsl:template match="@keyref[$show.csv.messages]">
        <xsl:message expand-text="yes">{$doc => replace('.*/', '')},{.},{ditaaccess:getKeyRefInfo(., $doc)},{ditaaccess:getKeyRefAbsoluteReference(., $doc) => replace('^file:.*/', '')}</xsl:message>
        <xsl:next-match/>
    </xsl:template>

    <xsl:template match="*[@keyref][$add.comments]">
        <xsl:copy>
            <xsl:apply-templates select="@*"/>
            <xsl:comment expand-text="yes">
getKeyRefInfo({@keyref}, {$doc}) = '{ditaaccess:getKeyRefInfo(@keyref, $doc)}'
getKeyRefAbsoluteReference({@keyref}, {$doc}) = '{ditaaccess:getKeyRefAbsoluteReference(@keyref, $doc)}'
</xsl:comment>
            <xsl:apply-templates select="node()"/>
        </xsl:copy>
    </xsl:template>

</xsl:stylesheet>
